"use strict";
var Tree_1 = require("./Tree");
var chai_1 = require("chai");
describe("Tree", function () {
    describe("reduce", function () {
        it("makes simple conversion (initial test)", function () {
            // filter in the format of a popular UI library
            var filter = {
                logic: "and",
                filters: [
                    {
                        logic: "or",
                        filters: [
                            {
                                operator: "eq",
                                field: "position",
                                value: "QA Engineer"
                            },
                            {
                                operator: "eq",
                                field: "position",
                                value: "UX Engineer"
                            }
                        ]
                    },
                    {
                        operator: "eq",
                        field: "age",
                        value: "20"
                    }
                ]
            };
            // translating it to elasticsearch QueryDSL
            var result = Tree_1.Tree.from(filter, function (x) { return x.filters; }).fold(function (acc, node) { return ({
                bool: (_a = {},
                    _a[node.logic == "or" ? "should" : "must"] = acc,
                    _a
                )
            }); var _a; }, function (leaf) { return ({
                // for simplicity, assuming operator to be always "eq"
                term: (_a = {}, _a[leaf.field] = leaf.value, _a)
            }); var _a; });
            chai_1.expect(result).to.eql({
                bool: {
                    must: [
                        {
                            bool: {
                                should: [
                                    { term: { position: "QA Engineer" } },
                                    { term: { position: "UX Engineer" } }
                                ]
                            }
                        },
                        { term: { age: "20" } }
                    ]
                }
            });
        });
    });
});
